package de.avatic.taric.serializer;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import de.avatic.taric.model.CertificateType;
import de.avatic.taric.repository.CertificateTypeRepository;
import org.springframework.data.jdbc.core.mapping.AggregateReference;
import org.springframework.stereotype.Component;

import java.io.IOException;

@Component
public class CertificateTypeReferenceSerializer extends JsonSerializer<AggregateReference<CertificateType, Integer>> {

    private final CertificateTypeRepository certificateTypeRepository;

    public CertificateTypeReferenceSerializer(CertificateTypeRepository certificateTypeRepository) {
        this.certificateTypeRepository = certificateTypeRepository;
    }

    @Override
    public void serialize(AggregateReference<CertificateType, Integer> value, JsonGenerator gen, SerializerProvider serializer) throws IOException {
        if (value != null) {
            CertificateType type = certificateTypeRepository.findById(value.getId())
                    .orElse(null);

            gen.writeObject(type);
        } else {
            gen.writeNull();
        }
    }

}
